package net.northking.cctp.element.string.enums;

import com.alibaba.fastjson.JSON;
import net.northking.cctp.element.core.type.EnumClass;

import java.util.*;

/**
 * TypeConversionEnum
 *
 * @author fengxiang.zhang
 * @since 1.0
 */
public enum TypeConversionProcessEnum implements EnumClass {
    capitalize("首字母大写", "0"),
    uncapitalize("首字母小写", "1"),
    lowerCase("字符串转小写", "2"),
    upperCase("字符串转大写", "3"),
    ;

    private String key;
    private String value;

    TypeConversionProcessEnum(String key, String value) {
        this.key = key;
        this.value = value;
    }

    public static TypeConversionProcessEnum from(String value) {
        for (TypeConversionProcessEnum item : TypeConversionProcessEnum.values()) {
            if (item.value.equals(value)) {
                return item;
            }
        }
        throw new IllegalArgumentException("未知的转换类型:" + value);
    }

    @Override
    public String getEnumData() {
        List<Map<String, Object>> result = new ArrayList<>();
        for (TypeConversionProcessEnum item : EnumSet.allOf(TypeConversionProcessEnum.class)) {
            Map<String, Object> one = new HashMap(1);
            one.put("label", item.key);
            one.put("value", item.value);
            result.add(one);
        }
        return JSON.toJSONString(result);
    }
}
